///////////////////////////////////////////////////////////////////////////////////////////////
// Open Eggbert: Free recreation of the computer game Speedy Eggbert.
// Copyright (C) 2024 the original author or authors.
//
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation, either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see 
// <https://www.gnu.org/licenses/> or write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
///////////////////////////////////////////////////////////////////////////////////////////////
package com.openeggbert.core.utils;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;
import com.pixelgamelibrary.Pixel;
import com.pixelgamelibrary.Platform;

/**
 *
 * @author robertvokac
 */
public class EmbeddedFileHandleFactory {

    private EmbeddedFileHandleFactory() {
        //Not meant to be instantiated.
    }

    public static FileHandle create(String name) {

        if (Pixel.app().isOneOfPlatforms(Platform.ANDROID, Platform.WEB)) {
            return Gdx.files.internal(name);
        } else {
            return Gdx.files.classpath(name);

        }
    }

}
